JavaScript/jQuery DateRangeBox - Accessibility

Accessibility Features Overview

NOTE
The overall accessibility level of your application depends on the DateRangeBox features that you use.
Accessibility Requirement Support Level
Right-to-Left Support
Keyboard Navigation Support
Screen Reader Support
Contrast Color Theme
Mobile Device Support
Lighthouse Accessibility Validation
Axe Accessibility Validation
WAVE Accessibility Validation
Section 508 Support
WCAG 2.x Support
  • - All component features meet the requirement
  • - Some component features may not meet the requirement
  • - Accessibility requirement is not supported

Accessibility Standards Compliance

The DateRangeBox component complies to all Section 508 and WCAG 2.x standards criteria except the following:

Section 508 criteria WCAG 2.x criteria Exception description
- 1.3.1 Info and Relationships (Level A) DateRangeBox does not pronounce selected range in multiselect mode.

Keyboard Navigation

A user can use the following keys to interact with the DateRangeBox component:

Value Picker Type Key Action
Input Field Alt + ↓ Opens the date/time picker.
Alt + ↑ / Esc Closes the date/time picker.
Calendar ← → ↑ ↓ Moves focus to the day nearby.
Page Up or Ctrl + ← Displays the previous month.
Page Down or Ctrl + → Displays the next month.
Enter Selects the focused day.
Ctrl + ↑ Increases zoomLevel.
Ctrl + ↓ Decreases zoomLevel.
Home Moves focus to the first date in the view.
End Moves focus to the last date in the view.

Use the registerKeyHandler(key, handler) method to implement a custom handler for a key.

JavaScript
  • function registerKeyHandlers () {
  • const dateRangeBox = $("#dateRangeBoxContainer").dxDateRangeBox("instance");
  • dateRangeBox.registerKeyHandler("backspace", function(e) {
  • // The argument "e" contains information on the event
  • });
  • dateRangeBox.registerKeyHandler("space", function(e) {
  • // ...
  • });
  • }

Screen Reader Support

The DateRangeBox component supports screen readers and complies to WAI-ARIA standards.

To improve accessibility, use the startDateInputAttr and endDateInputAttr properties to specify aria-label for the component. You do not need to specify aria-label if you use startDateLabel or endDateLabel correspondingly.

React DateRangeBox - Accessibility

Accessibility Features Overview

NOTE
The overall accessibility level of your application depends on the DateRangeBox features that you use.
Accessibility Requirement Support Level
Right-to-Left Support
Keyboard Navigation Support
Screen Reader Support
Contrast Color Theme
Mobile Device Support
Lighthouse Accessibility Validation
Axe Accessibility Validation
WAVE Accessibility Validation
Section 508 Support
WCAG 2.x Support
  • - All component features meet the requirement
  • - Some component features may not meet the requirement
  • - Accessibility requirement is not supported

Accessibility Standards Compliance

The DateRangeBox component complies to all Section 508 and WCAG 2.x standards criteria.

Keyboard Navigation

A user can use the following keys to interact with the DateRangeBox component:

Value Picker Type Key Action
Input Field Alt + ↓ Opens the date/time picker.
Alt + ↑ / Esc Closes the date/time picker.
Calendar ← → ↑ ↓ Moves focus to the day nearby.
Page Up or Ctrl + ← Displays the previous month.
Page Down or Ctrl + → Displays the next month.
Enter Selects the focused day.
Ctrl + ↑ Increases zoomLevel.
Ctrl + ↓ Decreases zoomLevel.
Home Moves focus to the first date in the view.
End Moves focus to the last date in the view.

Use the registerKeyHandler(key, handler) method to implement a custom handler for a key.

App.js
  • import React from 'react';
  • import 'devextreme/dist/css/dx.light.css';
  •  
  • import { DateRangeBox } from 'devextreme-react/date-range-box';
  •  
  • class App extends React.Component {
  • constructor(props) {
  • super(props);
  •  
  • this.dateRangeBoxRef = React.createRef();
  • }
  •  
  • render() {
  • return (
  • <DateRangeBox ref={this.dateRangeBoxRef} />
  • );
  • }
  •  
  • get dateRangeBox() {
  • return this.dateRangeBoxRef.current.instance;
  • }
  •  
  • componentDidMount() {
  • this.dateRangeBox.registerKeyHandler('backspace', function(e) {
  • // The argument "e" contains information on the event
  • });
  • this.dateRangeBox.registerKeyHandler('space', function(e) {
  • // ...
  • });
  • }
  • }
  •  
  • export default App;

Screen Reader Support

The DateRangeBox component supports screen readers and complies to WAI-ARIA standards.

To improve accessibility, use the startDateInputAttr and endDateInputAttr properties to specify aria-label for the component. You do not need to specify aria-label if you use startDateLabel or endDateLabel correspondingly.